]> git.pld-linux.org Git - packages/rpm-build-macros.git/blob - rpm.macros
- target_base_arch for arm
[packages/rpm-build-macros.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros.
3 # <http://www.pld-linux.org/>
4
5 # can be used by builder script to check for version
6 %rpm_build_macros       %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
8 %epoch          0
9 %x8664          x86_64 amd64 ia32e
10 %arm            armv3l armv4b armv4l armv5teb armv5tel
11
12 # kernel compiler
13 %kgcc           %{__cc}
14 %kgcc_package   gcc
15
16 # compiler version
17 %cc_version     %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
18 %cxx_version    %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
19
20 %__rm           /bin/rm --interactive=never
21
22 # Build system path macros.
23 %__autoconf     autoconf %{?debug:-Wall}
24 %__automake     automake -a -c -f --foreign
25 %__autopoint    autopoint --force
26
27 # add parallel build flags: -jN
28 #
29 # if you want to disable parallel build do:
30 # echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
31 #
32 %__make         /usr/bin/make %{?_smp_mflags}
33 %__scons        /usr/bin/scons %{?_smp_mflags}
34 %__waf          /usr/bin/waf %{?_smp_mflags}
35 %__cmake        /usr/bin/cmake
36
37 %_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
38                                 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
39
40 %__gettextize { \
41         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
42                 gettextize --copy --force --no-changelog; \
43         else \
44                 gettextize --copy --force --no-changelog --intl; \
45         fi; \
46         if [ ! -f po/Makevars ]; then \
47                 cp -f po/Makevars{.template,}; \
48         fi; \
49 }
50
51 %__glib_gettextize      glib-gettextize --copy --force
52 %__gnome_doc_common     gnome-doc-common --copy
53 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
54 %__gtkdocize            gtkdocize --copy
55 %__intltoolize          intltoolize --copy --force
56 %__libtoolize           libtoolize --copy --force --install
57
58 # topdir is where builder script lives,
59 # fallback to old style if SPECS/SOURCES dirs were found.
60 %_topdir    %{expand:%%global _topdir %(
61         if [ -d SPECS -a -d SOURCES ]; then
62                 # old style rpmdir: in topdir
63                 pwd
64         elif [ -d ../SPECS -a -d ../SOURCES ]; then
65                 # old style rpmdir: in subdir
66                 cd ..; pwd
67         elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
68                 # if old style rpm dir exist, go with it
69                 echo $HOME/rpm; \
70         elif [ -x ../builder -a ! -d ../builder ]; then
71                 # relative new style rpmdir: in package dir
72                 cd ..; pwd
73         elif [ -x builder -a ! -d builder ]; then
74                 # relative new style rpmdir: in packages
75                 pwd
76         elif [ -x packages/builder -a ! -d packages/builder ]; then
77                 # relative new style rpmdir: packages dir in current dir
78                 cd packages; pwd
79         else
80                 # fallback to new style rpmdir
81                 echo $HOME/rpm/packages
82         fi; \
83 )}%_topdir
84
85 # if %{_topdir}/SPECS exists, it's old style structure
86 %_specdir       %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
87 %_sourcedir             %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
88
89 # BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
90 # if they don't exist assume we are having custom topdir (which is not named as
91 # "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
92 # NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
93 %_builddir              %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
94 %_rpmdir                %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
95 %_srcrpmdir             %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
96
97 #       The number of cvs changelog entries kept when building package.
98 %_buildchangelogtruncate 20
99
100 %dependencytracking     %{nil}
101
102 #       Relations between package names that cause dependency loops
103 #       with legacy packages that cannot be fixed. Relations are
104 #       specified as
105 #               p>q
106 #       where package p has a Requires: on something that package q Provides:
107 #
108 # XXX   Note: that there cannot be any whitespace within the string "p>q",
109 #       and that both p and q are package names (i.e. no version/release).
110 %_dependency_whiteout   %{nil}
111
112 #-----------------------------------------------------------------
113 #
114 # (re)definition of %{rpm*flags} with %filterout_* support
115 # BuildRequires:        awk
116 # BuildRequires:        rpmbuild(macros) >= 1.315
117 #
118 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
119 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
120 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
121 # %rpmcppflags  = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
122 # %rpmldflags   = %optldflags - %filterout_ld
123 #
124 # Regular expressions are supported, but to avoid some character be treated
125 # as regular expression it must be escaped twice.
126
127 %filter_out                                             \
128         for (i = 1; i in I; i++) {      A=0;    \
129                 for (f in F) {                          \
130                         if (I[i] ~ "^" F[f] "$") A=1;   \
131                 };                                                      \
132                 if (!A) printf(I[i] FS);        \
133         }
134
135 %rpmcflags %(awk 'BEGIN {
136         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
137         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
138         %{filter_out}
139 }')
140
141 %rpmcxxflags %(awk 'BEGIN {
142         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
143         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
144         %{filter_out}
145 }')
146
147 %rpmcppflags %(awk 'BEGIN {
148         split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
149         split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
150         %{filter_out}
151 }')
152
153 %rpmldflags %(awk 'BEGIN {
154         split("%{?optldflags}",I);
155         split("%{?filterout_ld}",F)
156         %{filter_out}
157 }')
158
159 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
160 # but, don't use it, better use gcc as linker
161 %ld_rpmldflags %(awk 'BEGIN {
162         split("%{rpmldflags}",F);
163         for (f in F) {
164                 s = F[f];
165                 if (s ~ /^-Wl,/) {
166                         s = substr(s,5);
167                         gsub(/,/," ",s);
168                 };
169                 printf(s FS);
170         };
171 }')
172
173 #-----------------------------------------------------------------
174 #
175 #  Generate a command which cleans environment, leaving only the
176 # most important variables.
177 #  If any spec requires any additional environment it should
178 # redefine %_preserve_env in following manner:
179 #
180 #       # ADDITIONAL_VAR is required because [a good reason here]
181 #       %define _preserve_env ADDITIONAL_VAR
182
183 %_preserve_env_base     PATH HOME TMP TMPDIR SSH_AUTH_SOCK
184
185 # "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
186 %_clean_env             %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
187         split("%{?_preserve_env}", P);
188         for (i in P) {
189                 p = P[i];
190                 if (!ENVIRON[p] || d[p]) {
191                         continue;
192                 }
193                 d[p] = 1;
194                 split(ENVIRON[p], V, "");
195                 val = p "=";
196                 for (j = 1; j in V; j++) {
197                         v = V[j];
198                         if (v == q)
199                                 v = qq;
200                         else if (v == "\\"")
201                                 v = q2q;
202                         else if (v == "\\\\")
203                                 v = "\\\\\\\\";
204                         else
205                                 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
206                         val = val "" v;
207                 }
208                 printf(val " ");
209         }
210 }')
211
212 #-----------------------------------------------------------------
213 %configure2_13 { \
214  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
215  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
216  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
217  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
218  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
219  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
220  CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
221  %{?__cc:CC="%{__cc}" ; export CC ; } \
222  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
223  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
224         --host=%{_target_platform} \
225         --prefix=%{_prefix} \
226         --exec-prefix=%{_exec_prefix} \
227         --bindir=%{_bindir} \
228         --sbindir=%{_sbindir} \
229         --sysconfdir=%{_sysconfdir} \
230         --datadir=%{_datadir} \
231         --includedir=%{_includedir} \
232         --libdir=%{_libdir} \
233         --libexecdir=%{_libexecdir} \
234         --localstatedir=%{_localstatedir} \
235         --sharedstatedir=%{_sharedstatedir} \
236         --mandir=%{_mandir} \
237         --infodir=%{_infodir} \
238         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
239         %{dependencytracking} \
240 }
241
242 %cmake { \
243 CC="%{__cc}" \
244 CXX="%{__cxx}" \
245 CFLAGS="%{rpmcflags}" \
246 CXXFLAGS="%{rpmcxxflags}" \
247 LDFLAGS="%{rpmldflags}" \
248 %{__cmake} \
249 }
250
251 %scons { \
252 %{__scons} \
253         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
254         CFLAGS="${CFLAGS:-%rpmcflags}" \
255         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
256         FFLAGS="${FFLAGS:-%rpmcflags}" \
257         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
258         %{?__cc:CC="%{__cc}"} \
259         %{?__cxx:CXX="%{__cxx}"} \
260         libsuffix=%{_lib} \
261         prefix=%{_prefix} \
262 }
263
264 # waf. see waf.spec
265 %waf { \
266 CC="%{__cc}" \
267 CXX="%{__cxx}" \
268 CPP="%{__cpp}" \
269 CFLAGS="%{rpmcflags}" \
270 CXXFLAGS="%{rpmcxxflags}" \
271 %{__waf} \
272 }
273
274 #----------------------------------------------------------------
275 #%configure_cache 0
276 %configure_cache_file   %{buildroot}.configure.cache
277
278 %configure {./configure \
279         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
280         CFLAGS="${CFLAGS:-%rpmcflags}" \
281         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
282         FFLAGS="${FFLAGS:-%rpmcflags}" \
283         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
284         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
285         %{?__cc:CC="%{__cc}"} \
286         %{?__cxx:CXX="%{__cxx}"} \
287         --host=%{_target_platform} \
288         --build=%{_target_platform} \
289         --prefix=%{_prefix} \
290         --exec-prefix=%{_exec_prefix} \
291         --bindir=%{_bindir} \
292         --sbindir=%{_sbindir} \
293         --sysconfdir=%{_sysconfdir} \
294         --datadir=%{_datadir} \
295         --includedir=%{_includedir} \
296         --libdir=%{_libdir} \
297         --libexecdir=%{_libexecdir} \
298         --localstatedir=%{_localstatedir} \
299         --sharedstatedir=%{_sharedstatedir} \
300         --mandir=%{_mandir} \
301         --infodir=%{_infodir} \
302         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
303         %{dependencytracking} \
304         %{?configure_cache:--cache-file=%{configure_cache_file}} \
305 }
306
307 # Simple macros to simplify adding bconded options to configure scripts.
308 #   Each macro requires bcond name and accepts optional option name, if option
309 # isn't specified bcond name is used as option name. Options returning
310 # --with and --enable also allow third argument which will be added as value
311 # ( --with-option=value or --enable-option=value ) in case or positive
312 # condition, but won't be added otherwise ( nothing or just --disable-option ).
313
314 # Requirements:
315 # BuildRequires: rpmbuild(macros) >= 1.527
316
317 # Usage example:
318 # %{__enable bcond} - returns --enable-bcond iff build condition is set
319 # %{__disable bcond option} - returns --enable-option iff bcond is not set
320 # %{__enable_disable bcond option value} - returns --enable-option=value if
321 #    bcond is set, returns --disable-option otherwise
322
323 # expand bconds to --enable-something and --disable-something
324 %__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
325 %__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
326 %__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
327
328 # same as above, but condition inverted
329 %__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
330 %__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
331 %__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
332
333 # expand bconds to --with-something and --without-something
334 %__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
335 %__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
336 %__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
337
338 # same as above, but condition inverted
339 %__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
340 %__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
341 %__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
342
343 #-----------------------------------------------------------------
344
345 # overload to insert debuginfo package
346 %prep \
347 %if 0%{?_enable_debug_packages}\
348 %{debug_package}\
349 %endif\
350 %%prep\
351 %{nil}
352
353 # Location of autoconf macros
354 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
355
356 # Location of omf files
357 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
358
359 # Location of pkgconfig files
360 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
361 # noarch pkgconfig files
362 %_npkgconfigdir /usr/share/pkgconfig
363
364 # Location of desktop files
365 %_desktopdir    /usr/share/applications
366 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
367
368 # Location of pixmaps for applnk/desktop files
369 %_pixmapsdir    /usr/share/pixmaps
370
371 # Location of themable icons for applnk/desktop files
372 %_iconsdir      /usr/share/icons
373
374 # Location of fonts directories
375 %_fontsdir      /usr/share/fonts
376
377 # Location of Gtk and associated libraries documentation
378 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
379
380 # Location of KDE documentation
381 %_kdedocdir     %{_defaultdocdir}/kde/HTML
382
383 # unsermake script
384 %__unsermake /usr/share/unsermake/unsermake
385
386 # Current date
387 %date           %(LC_ALL=C date +"%a %b %d %Y")
388
389 # Example files, programs, scripts...
390 %_examplesdir   /usr/src/examples
391
392 # Alternative kernel type/version
393 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
394
395 # The directory holding Linux kernel sources
396 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
397
398 # SysV-style initscripts dir
399 %_initddir              /etc/rc.d/init.d
400
401 # If non-empty "debug" macro defined, add "dbg" suffix to release number
402 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
403
404 # Bootstrap release macros.
405 # Usage:
406 #       %bcond_with     bootstrap
407 #       Release:        %{bootstrap_release 1}
408 #
409 # Package will have release 1 if built normally,
410 # and release 0.zzz.bootstrap if built with bootstrap
411 %bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
412
413 # -n drm to generate kernel%{_alt_kernel}-drm dependency
414 %releq_kernel(n:)               %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
415 %releq_kernel_up(n:)    %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
416 %releq_kernel_smp(n:)   %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
417
418 # -s post to generate Requires(post) dependency
419 %requires_releq_kernel(s:n:)            Requires%{-s:(%{-s*})}: %releq_kernel
420 %requires_releq_kernel_up(s:n:)         Requires%{-s:(%{-s*})}: %releq_kernel_up
421 %requires_releq_kernel_smp(s:n:)        Requires%{-s:(%{-s*})}: %releq_kernel_smp
422
423 # Requires name = version-release
424 %requires_releq()       %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
425 # Requires: name = version
426 %requires_eq()          %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
427 # Requires: name = version (version based on querying package %2)
428 %requires_eq_to(r)      %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
429
430 # Requires: name >= version
431 %requires_ge()          %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
432 # Requires: name >= version (version based on querying package %2)
433 %requires_ge_to(r)      %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
434
435 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
436
437 # kernel version-release handling
438 %__kernel_ver    %{expand:%%global __kernel_ver %( \\
439         Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
440         Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
441         echo ${Z:-ERROR}; \\
442 )}%__kernel_ver
443
444 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
445 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
446 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
447 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
448
449 # `uname -r` to be used in @release field
450 %_kernel_vermagic       %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
451
452 # sgml macros
453 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
454 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
455 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
456 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
457 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
458 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
459 %docbook_sgmlcat_fix() { for l in \
460 '' \
461 '  -- default decl --' \
462 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
463 '  -- hacks for opensp --' \
464 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
465 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
466 '' \
467 ; do echo $l; done >> %1 \
468 }
469
470 # vim - "
471
472 # minimum file size needed for compressed documents.
473 # just smaller files than this get larger when compressed.
474 # some stats:
475 # - 0 byte file compressed was 25 bytes .gz
476 # - 39 byte file was compressed as 57
477 # - with test/test.spec@man 158 byte file was compressed also 158
478 %_min_compress_bytes    159
479
480 #-----------------------------------------------------------------
481 # find and gzip all files in %{_mandir} and %{infodir}
482 #
483 # Requires: xargs, find
484 #
485 #%no_install_post_compress_docs 1
486 %__spec_install_post_compress_docs { \
487 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
488         for i in /usr/share/man /usr/X11R6/man; do \
489                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
490                         echo "Compress man pages: $i"; \
491                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
492                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
493                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
494                                 m=$(readlink $a); \
495                                 rm -f $a; \
496                                 echo .so ${m##*/} > $a; \
497                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
498                         done; \
499                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
500                 fi; \
501         done; \
502         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
503                 echo "Compress info pages: %{_infodir}"; \
504                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
505                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
506                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
507         fi; \
508 }; __spec_install_post_compress_docs } }
509
510 #-----------------------------------------------------------------
511 # Strip executable binaries and shared object files
512 #
513 # Requires: find, awk, strip, cut, xargs
514 #
515 # Special macros which affect this process:
516 #%no_install_post_strip 1               # disable stripping at all
517 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
518 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
519 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
520 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
521 #
522 %__spec_install_post_strip {%{!?debug: \
523 %{!?no_install_post_strip:__spec_install_post_strip() { \
524 if [ -d "$RPM_BUILD_ROOT" ]; then \
525         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
526                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
527                 if [ "$modulelist" ]; then \
528                         modulecount=$(echo "$modulelist" | wc -l); \
529                         printf "Stripping %d kernel modules..." $modulecount; \
530                         echo "$modulelist" | xargs -l512 chmod u+w; \
531                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
532                         echo "DONE"; \
533                 fi; \
534         fi; \
535         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
536         if [ -n "$filelist" ]; then \
537                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
538                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
539                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
540                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
541                 if [ -n "$elfexelist" ]; then \
542                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
543                         chmod u+w $elfexelist; \
544                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
545                         echo "DONE"; \
546                 fi; \
547                 if [ -n "$elfsharedlist" ]; then \
548                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
549                         chmod u+w $elfsharedlist; \
550                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
551                         echo "DONE"; \
552                 fi; \
553                 if [ -n "$archiveslist" ]; then \
554                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
555                         chmod u+w $archiveslist; \
556                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
557                         echo "DONE"; \
558                 fi; \
559         fi; \
560     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
561     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
562     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
563         if [ -n "$filelist_all" ]; then \
564                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
565                 chmod u+w $filelist_all; \
566                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
567                 echo "DONE"; \
568         fi; \
569         if [ -n "$filelist_unneeded" ]; then \
570                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
571                 chmod u+w $filelist_unneeded; \
572                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
573                 echo "DONE"; \
574         fi; \
575         if [ -n "$filelist_debug" ]; then \
576                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
577                 chmod u+w $filelist_debug; \
578                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
579                 echo "DONE"; \
580         fi; \
581 fi; }; __spec_install_post_strip } } }
582
583 #-----------------------------------------------------------------
584 # remove all RPATH from executable binaries and shared object files
585 #
586 # Requires: find, awk, cut, xargs, chrpath, uname
587 #
588 # Special macros which affect this process
589 #%no_install_post_chrpath       1       # disable chrpath at all
590 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
591 #
592 %__spec_install_post_chrpath {%{!?debug: \
593 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
594 if [ -d "$RPM_BUILD_ROOT" ]; then \
595         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
596         if [ -n "$files" ]; then \
597                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
598         fi; \
599         if [ -n "$objs" ]; then \
600                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
601                 echo "$objs" | \
602                 while read file; do \
603                         rpath= ; \
604                         chmod u+w "$file"; \
605                         for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
606                                         case $dir in \
607                                         '$ORIGIN' ) \
608                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
609                                                 else rpath="$rpath:$dir" ; fi ; \
610                                                 continue ; \
611                                                 ;; \
612                                         esac ; \
613                                         newdir=$(readlink -m "$dir"); \
614                                         [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
615                                         case $dir in \
616                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
617                                                 echo "remove-rpath: $dir in $file"; \
618                                                 ;; \
619                                         * ) \
620                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
621                                                 else rpath="$rpath:$dir" ; fi ; \
622                                                 ;; \
623                                         esac ; \
624                         done ; \
625                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
626                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
627                 done; \
628         fi; \
629 fi; }; __spec_install_post_chrpath } } }
630
631 # vim: "
632
633 #-----------------------------------------------------------------
634 # Find all shared object files with unresolved symbols. Warn
635 # and terminate if any found (termination can be turned off by define).
636 #%no_install_post_check_so 1
637 %__spec_install_post_check_so { \
638  __spec_install_post_check_so() { \
639     fail=0; \
640     printf "Searching for shared objects with unresolved symbols..."; \
641     for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
642         LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
643     done ; \
644     echo " DONE"; \
645     %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
646 }; __spec_install_post_check_so }}
647
648 #-----------------------------------------------------------------
649 # Find and gzip all kernel modules
650 #
651 # Requires: find
652 #
653 #%no_install_post_compress_modules      1
654 %__spec_install_post_compress_modules { \
655 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
656         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
657                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
658                 if [ "$q" ]; then \
659                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
660                         echo "$q" | xargs -r %{__gzip} -9nf; \
661                         echo "DONE"; \
662                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
663                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
664                 fi; \
665         fi; \
666 }; __spec_install_post_compress_modules } }
667
668 # Remove common Perl files we don't package
669 %__spec_install_post_perl_clean {\
670 %{!?no_install_post_perl_clean: \
671 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
672 } }
673
674 #-----------------------------------------------------------------
675 # Update GConf2 schemas
676 #
677 # Requires: GConf2
678 #
679 %gconf_schema_install() \
680         umask 022; \
681         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
682         /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
683 %{nil}
684
685 %gconf_schema_uninstall() \
686 if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
687         umask 022; \
688         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
689         /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
690 fi; \
691 %{nil}
692
693 #-----------------------------------------------------------------
694 # Update desktop MIME database
695 # requires: desktop-file-utils
696 %update_desktop_database() {{ \
697         umask 022; \
698         /usr/bin/update-desktop-database -q; \
699 };} \
700 %{nil}
701
702 %update_desktop_database_post %update_desktop_database
703
704 %update_desktop_database_postun() {{ \
705 if [ "$1" = "0" ]; then \
706         %update_desktop_database \
707 fi; \
708 };} \
709 %{nil}
710
711 #-----------------------------------------------------------------
712 # Update shared MIME info database
713 # requires: shared-mime-info
714 #
715 %update_mime_database() {{ \
716         umask 022; \
717         /usr/bin/update-mime-database %{_datadir}/mime; \
718 };} \
719 %{nil}
720
721 #-----------------------------------------------------------------
722 # Update icon cache
723 # requires: gtk+
724 #
725 %update_icon_cache() {{ \
726         umask 022; \
727         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
728 };} \
729 %{nil}
730
731 #-----------------------------------------------------------------
732 # Update scrollkeeper database
733 # requires: scrollkeeper
734 #
735 %scrollkeeper_update_post() \
736         /usr/bin/scrollkeeper-update -q; \
737 %{nil}
738
739 %scrollkeeper_update_postun() \
740 if [ "$1" = "0" ]; then \
741         /usr/bin/scrollkeeper-update -q; \
742 fi; \
743 %{nil}
744
745 #-----------------------------------------------------------------
746 # post %install sequence:
747 # - autodeps exceptions
748 # - compress all man and info pages,
749 # - strip all ELF executables and ELF shared objects if not %debug.
750 # - compress kernel modules if any
751
752 ###################################################################
753 # Requires/Provides automation
754 # exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
755 #
756 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
757 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
758 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
759 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
760 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
761
762 #%_noautocompressdoc    %{nil}
763 #
764 %_missing_doc_files_terminate_build     1%{nil}
765 %_unpackaged_files_terminate_build      %{nil}
766 # (X)emacs support
767 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
768 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
769 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
770
771 %__php_provides %{nil}
772 %__php_requires %{nil}
773 %__perl_provides %{nil}
774 %__perl_requires %{nil}
775 %__mono_provides %{nil}
776 %__mono_requires %{nil}
777
778 # Perl specific macro definitions.
779 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
780 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
781 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
782 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
783 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
784 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
785
786 # Ruby
787 %__ruby                         /usr/bin/ruby
788 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
789 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
790 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
791 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
792 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
793 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
794 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
795 %ruby_rdocdir           /usr/share/rdoc
796 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
797 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
798 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
799
800 %php_pear_dir           /usr/share/pear
801 %php_data_dir           /usr/share/php
802 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
803 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
804 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
805
806 # extract php/zend api versions
807 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
808 %php_minor_version              %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
809 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
810 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
811 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
812 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
813 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
814 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
815
816 # helper macro
817 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
818
819 # macros for public use
820 # for php extensions (php-pecl)
821 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
822 %{__php_api_requires zend_module_api} \
823 %{__php_api_requires -v %php_major_version debug php_debug} \
824 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
825
826 # for zend extensions
827 %requires_zend_extension %{__php_api_requires zend_module_api} \
828 %{__php_api_requires zend_extension_api} \
829 %{__php_api_requires -v %php_major_version debug php_debug} \
830 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
831
832 # for php pdo modules (php-pecl-PDO_*)
833 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
834
835 # for using PHP post scripts. for PHP >= 5.0
836 %php_webserver_restart \
837 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
838 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
839 if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
840         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
841         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
842                 %service -q php-fcgi restart \
843         fi \
844 fi \
845 if [ -x /etc/rc.d/init.d/php-fpm ]; then \
846         %service -q php-fpm restart \
847 fi \
848 %{nil}
849
850 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
851 %php4_webserver_restart \
852 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
853 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
854 if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
855         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
856         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
857                 %service -q php-fcgi restart \
858         fi \
859 fi \
860 %{nil}
861
862 # X.org helper macros
863 %__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
864 %__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
865
866 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
867 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
868 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
869 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
870 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
871 # vim: '
872
873 %requires_xorg_xserver_extension \
874 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
875 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
876 %{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
877 %{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
878 %{nil}
879
880 %requires_xorg_xserver_xinput \
881 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
882 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
883 %{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
884 %{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
885 %{nil}
886
887 %requires_xorg_xserver_font \
888 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
889 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
890 %{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
891 %{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
892 %{nil}
893
894 %requires_xorg_xserver_videodrv \
895 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
896 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
897 %{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
898 %{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
899 %{nil}
900
901 # TCL specific macro definitions.
902 # TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
903 %tcl_version    %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
904 %tcl_sitearch   %{_libdir}/tcl%{tcl_version}
905 %tcl_sitelib    %{_datadir}/tcl%{tcl_version}
906
907 # Python specific macro definitions.
908 # python main version
909 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
910
911 # directories
912 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
913 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
914 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
915 %py_incdir              /usr/include/python%{py_ver}
916 %py_sitedir             %{py_libdir}/site-packages
917 %py_sitescriptdir %{py_scriptdir}/site-packages
918 %py_dyndir              %{py_libdir}/lib-dynload
919
920 # pure python modules compilation
921 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
922
923 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
924
925 # Software written in Python language require Python with main version
926 %pyrequires_eq() Requires:      %1
927
928 # Python 3.x
929 # python main version
930 %__python3                      python3
931 %py3_ver                        %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
932
933 # directories
934 %py3_prefix             %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
935 %py3_libdir             %{py3_prefix}/%{_lib}/python%{py3_ver}
936 %py3_scriptdir  %{py3_prefix}/share/python%{py3_ver}
937 %py3_incdir             /usr/include/python%{py3_ver}
938 %py3_sitedir            %{py3_libdir}/site-packages
939 %py3_sitescriptdir %{py3_scriptdir}/site-packages
940 %py3_dyndir             %{py3_libdir}/lib-dynload
941
942 # pure python modules compilation
943 %py3_comp               %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
944
945 %py3_ocomp              %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
946
947 # Hardlink binary identical .pyc and .pyo files
948 %__spec_install_post_py_hardlink {\
949 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
950 local a b c=0 t=0; \
951 if [ -d "$RPM_BUILD_ROOT" ]; then \
952         find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
953         while read a; do \
954                 b="${a%.pyc}.pyo"; \
955                 if cmp -s "$a" "$b"; then \
956                         ln -f "$a" "$b"; \
957                         c=$((c + 1)); \
958                 fi; \
959                 t=$((t + 1)); \
960         done < __rpm_pyc; \
961         [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
962         rm -f __rpm_pyc; \
963 fi; \
964 }; __spec_install_post_py_hardlink } }
965
966 # remove python sources, so that check-files won't complain
967 %py_postclean() \
968 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
969  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
970 done \
971 %{nil}
972
973 %py3_postclean() \
974 for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
975  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
976 done \
977 %{nil}
978
979 # depmod macro
980 %depmod() { \
981 umask 022; \
982 if [ -e /boot/System.map-%1 ]; then \
983         /sbin/depmod -a -F /boot/System.map-%1 %1; \
984 else \
985         if [ -e /boot/System.map ]; then \
986                 /sbin/depmod -a -F /boot/System.map %1; \
987         else \
988                 /sbin/depmod -a %1; \
989         fi \
990 fi; \
991 }
992
993 # XMMS specific macros
994 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
995 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
996 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
997 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
998 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
999 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1000 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1001 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1002 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1003 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1004
1005 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1006
1007 # user/group checking macros
1008 #
1009 # Usage:
1010 #       %userremove myuser
1011 #
1012 %userremove     /usr/lib/rpm/user_group.sh user del
1013 %groupremove    /usr/lib/rpm/user_group.sh group del
1014 #
1015 # Usage:
1016 #       if %usertestrm myuser; then
1017 #               /usr/sbin/userdel -r myuser
1018 # Note:
1019 #       use these macros only if you need to call userdel/groupdel with
1020 #       a non-standard option or take an extra action; otherwise use the
1021 #       %userremove/%groupremove macros
1022 #
1023 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
1024 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
1025 # user group membership management macros
1026 #
1027 # Usage:
1028 #       %addusertogroup [-q] myuser agroup
1029 #
1030 #  -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1031 #
1032 # Requirements:
1033 # BuildRequires:        rpmbuild(macros) >= 1.515
1034 %addusertogroup(q)      quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1035 %{nil}
1036
1037 # banner support (useful in {pre,post}{,un} and triggers)
1038 #
1039 # Usage:
1040 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
1041 # the banner text, the banner text
1042 # the banner text, and following line
1043 #EOF
1044 # You can use any form of here-document, <<'EOF' <<-EOT will do.
1045 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1046 #
1047 # -a   - append to the banner
1048 # -e   - send to stderr instead of stdout
1049 # -n   - no show banner (overrides -t)
1050 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1051 #
1052 # Tests:
1053 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1054 # rpm -E 'date | %banner -e banner' > m; sh -x m
1055 #
1056 %banner(aent:) ( \
1057 RPM_SCRIPTVERBOSITY=5 \
1058 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1059 if [ -x /usr/bin/banner.sh ]; then \
1060         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1061 else \
1062         CMD="cat%{-e: >&2}" \
1063 fi \
1064 eval $CMD %{?2:%2}%{?3: %3}) \
1065 %{nil}
1066
1067 # useradd/groupadd macros
1068 # Author: Elan Ruusamäe <glen@pld-linux.org>
1069 #
1070 # Usage:
1071 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1072 #   [-g initial_group] [-G group[,...]] login
1073 #
1074 #  -u uid. REQUIRED
1075 #  -g gid/group. REQUIRED
1076 #  -s defaults to /bin/false
1077 #  -d defaults to /usr/share/empty
1078 #  -c No default
1079 #  -r is accepted but ignored (it's always set)
1080 #  -k skeleton dir. defaults to /usr/share/empty
1081 # rpm specific flags
1082 #  -P package name. defaults to %{name}
1083 #
1084 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1085 %{!-u:%{error:useradd: Required argument -u missing}} \
1086 %{!-g:%{error:useradd: Required argument -g missing}} \
1087 %{!?1:%{error:useradd: Required parameter login missing}} \
1088 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1089         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1090                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1091                 exit 1 \
1092         fi \
1093 else \
1094         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1095         /usr/sbin/useradd \\\
1096                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1097                 -u %{-u*} \\\
1098                 -r \\\
1099                 -d %{-d*}%{!-d:/usr/share/empty} \\\
1100                 -s %{-s*}%{!-s:/bin/false} \\\
1101                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1102                 -g %{-g*} \\\
1103                 %{-M} \\\
1104                 %{-G:-G %{-G*}} \\\
1105                 %{expand:%{%{#}}} 1>&2 || exit $? \
1106         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1107 fi;
1108 # vim: "
1109
1110 # Usage:
1111 #   %groupadd [-P package] [-g gid] group
1112 #
1113 # -g gid. REQUIRED
1114 #
1115 # Sample:
1116 #   %groupadd -P %{name}-base -g %{gid} %{name}
1117
1118 %groupadd(g:P:rfo)      \
1119 %{!-g:%{error:groupadd: Required argument -g missing}} \
1120 %{!?1:%{error:groupadd: Required parameter group missing}} \
1121 if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1122         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1123                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1124                 exit 1 \
1125         fi \
1126 else \
1127         echo "Adding group %{1} GID=%{-g*}." \
1128         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1129         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1130 fi;
1131
1132 # webapp macros
1133 # Author: Elan Ruusamäe <glen@pld-linux.org>
1134 #
1135 # The config is installed/removed inside trigger, this means that you can any
1136 # time install apache1/apache/lighttpd package and the configuration file is
1137 # updated. if you don't need the config for various reason for specific
1138 # webserver, just remove the symlink from config directory using webapp
1139 # program. the trigger will not recreate the symlink on upgrades. In other
1140 # words the config is linked to webserver config directory on first install of
1141 # PACKAGE or WEBSERVER.
1142 #
1143 # Add package's webserver config to webserver webapps dir.
1144 # Usage:
1145 #   %webapp_register [-f] WEBSERVER WEBAPP
1146 #
1147 %webapp_register(f) \
1148 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1149 if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1150         /usr/sbin/webapp register %1 %2\
1151 fi\
1152 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1153 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1154         %{expand:%service -q %%1 reload}\
1155 fi\
1156 %{nil}
1157
1158 # Remove package's config from webserver webapps dir.
1159 # Usage:
1160 #   %webapp_register [-f] WEBSERVER WEBAPP
1161 %webapp_unregister(f) \
1162 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1163 # remove link if either of the packages are gone \
1164 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1165         /usr/sbin/webapp unregister %1 %2\
1166         %{expand:%service -q %%1 reload}\
1167 fi \
1168 %{nil}
1169
1170 # service macro.
1171 # Author: Elan Ruusamäe <glen@pld-linux.org>
1172 #
1173 # calls usual service restart on package %post, but skips the restart if
1174 # administrator has disabled automatic service restarts in either global
1175 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1176 #
1177 # Usage:
1178 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1179 #
1180 #  -q be silent when service isn't started (for scriplets restaring other package's services)
1181 #  -n NOOP mode, do not actually restart service
1182 #
1183 # Requirements:
1184 # BuildRequires:        rpmbuild(macros) >= 1.268
1185 # Requires:     rc-scripts
1186 # -n option:
1187 # BuildRequires:        rpmbuild(macros) >= 1.450
1188 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1189
1190
1191 # Java macros. based on jpackage macros.java
1192 #
1193 # Root directory where all Java VMs/SDK/JREs are installed.
1194 %_jvmdir                %{_libdir}/jvm
1195
1196 # Root directory where all Java VMs/SDK/JREs expose their jars
1197 %_jvmjardir             %{_libdir}/jvm-exports
1198
1199 # Root directory for all Java VM/SDK/JRE's private things.
1200 %_jvmprivdir    %{_libdir}/jvm-private
1201
1202 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1203 %_jvmlibdir             %{_libdir}/jvm
1204
1205 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
1206 %_jvmdatadir    %{_datadir}/jvm
1207
1208 # Root directory for all configurations parts of Java VM/SDK/JRE's
1209 %_jvmsysconfdir %{_sysconfdir}/jvm
1210
1211 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1212 %_jvmcommonlibdir       %{_libdir}/jvm-common
1213
1214 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1215 %_jvmcommondatadir      %{_datadir}/jvm-common
1216
1217 # Root directory for all common configurations parts of Java VM/SDK/JRE's
1218 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
1219
1220 # Directory where arch-specific (JNI) version-independent jars are installed.
1221 %_jnidir                %{_libdir}/java
1222
1223
1224 # JDK selection. Set this to name of the JDK implementation to use
1225 # insead of the system default
1226 #%use_jdk               icedtea6
1227
1228 # expands to the value with right jdk for BuildRequires header
1229 # 'jdk' if %%use_jdk is not defined,  jdk(%%use_jdk) otherwise
1230 # The requirement will not replace current 'default' JDK
1231 %required_jdk   jdk%{?use_jdk:(%{use_jdk})}
1232
1233 %buildrequires_jdk BuildRequires: %required_jdk
1234
1235 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1236
1237 %_javasrcdir    %{_usrsrc}/java
1238
1239 %ant                    JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1240 %jar                    %{java_home}/bin/jar
1241 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1242 %javac                  %{java_home}/bin/javac
1243 %javadoc                %{java_home}/bin/javadoc
1244
1245 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1246
1247 %jpackage_script() \
1248 install -d $RPM_BUILD_ROOT%{_bindir}\
1249 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1250 #!/bin/sh\
1251 #\
1252 # %{name} script\
1253 # JPackage Project <http://www.jpackage.org/>\
1254 \
1255 # Source functions library\
1256 . %{_javadir}-utils/java-functions\
1257 \
1258 # Source system prefs\
1259 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1260     . %{_sysconfdir}/java/%{name}.conf\
1261 fi\
1262 \
1263 # Source user prefs\
1264 if [ -f $HOME/.%{name}rc ]; then\
1265     . $HOME/.%{name}rc\
1266 fi\
1267 \
1268 # Configuration\
1269 MAIN_CLASS=%1\
1270 BASE_FLAGS=%2\
1271 BASE_OPTIONS=%3\
1272 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1273 \
1274 # Set parameters\
1275 set_jvm\
1276 set_classpath $BASE_JARS\
1277 set_flags $BASE_FLAGS\
1278 set_options $BASE_OPTIONS\
1279 \
1280 # Let's start\
1281 run "$@"\
1282 EOF
1283
1284 # jpackage 1.7
1285 # Directory for maven depmaps
1286 #
1287 %_mavendepmapdir /etc/maven
1288 %_mavendepmapfragdir /etc/maven/fragments
1289
1290 #
1291 # add_to_depmap adds an entry to the depmap. The arguments are:
1292 #
1293 # %1 the original groupid
1294 # %2 the original artifact id
1295 # %3 the version
1296 # %4 the new groupid
1297 # %5 the new artifactid
1298 #
1299
1300 %add_to_maven_depmap() \
1301 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1302 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1303 <dependency>\
1304     <maven>\
1305         <groupId>%1</groupId>\
1306         <artifactId>%2</artifactId>\
1307         <version>%3</version>\
1308     </maven>\
1309     <jpp>\
1310         <groupId>%4</groupId>\
1311         <artifactId>%5</artifactId>\
1312         <version>%3</version>\
1313     </jpp>\
1314 </dependency>\
1315 \
1316 EOF\
1317 %{nil}
1318
1319 #==============================================================================
1320 #
1321 # update_maven_depmap updates the main maven depmap
1322 #
1323 %update_maven_depmap() \
1324 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1325 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1326 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1327 fi\
1328 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1329
1330 # JAVA macros specific for PLD
1331
1332 # Directory for tomcat context configuration files
1333 %_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1334
1335 # Tomcat cache path
1336 %_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1337
1338 # Clear tomcat cache
1339 # Author: Paweł Zuzelski <pawelz@pld-linux.org>
1340 #
1341 # Usage:
1342 # %%tomcat_clear_cache appname
1343 #
1344 # Call this script in %postun scriptlet. It will remove compiled jsps related to
1345 # given app.
1346 #
1347 %tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1348
1349 # PEAR install macros
1350 # Author: Elan Ruusamäe <glen@pld-linux.org>
1351 #
1352 # Usage:
1353 #       %%pear_package_setup ...
1354 #
1355 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1356 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1357 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1358 # -D     - pass -D to %setup (so the build dir is not removed)
1359 # -c     - register channel from local channel.xml file
1360 # -d     - pass -d arg to pearcmd
1361 #
1362 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1363 # destination hierarchy. you should copy the tree to buildroot after
1364 # patching/reorganizing with %%pear_package_install.
1365 #
1366 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1367 # line endings.
1368 #
1369 # the pear install process output is recorded to install.log, you should put it
1370 # to %%doc for later debug or just for information.
1371 #
1372 # additionally additional-packages.txt is produced if it was detected that the
1373 # package has optional dependencies. the file format is suitable of displaying
1374 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1375 # automatically added for this file.
1376
1377
1378 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1379 %__pear_install_log \
1380 tee install.log \
1381 # make post message of optional packages \
1382 grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1383 if [ -s optional-packages.txt ]; then \
1384         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1385 else \
1386         rm -f optional-packages.txt \
1387 fi \
1388 %{nil}
1389
1390 # command invoking pear cli
1391 %__pear /usr/bin/pear
1392
1393 %pear_install(a:d:n:zD) \
1394 %__pear \\\
1395         -c %{builddir}/pearrc \\\
1396         -d doc_dir=/docs \\\
1397         -d temp_dir=/tmp \\\
1398         -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1399         -d bin_dir=%{_bindir} \\\
1400         -d data_dir=%{php_pear_dir}/data \\\
1401         -d test_dir=%{php_pear_dir}/tests \\\
1402         %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1403         install \\\
1404         --packagingroot=%{builddir} \\\
1405         --offline \\\
1406         --nodeps \\\
1407         %{-f:--force} \\\
1408         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1409         %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1410 %{nil}
1411
1412 # The main macro.
1413 # using this macro will append optional-packages.txt to the nocompressdoc list
1414 # as it's displayed to user after package install. and adding additional gzip
1415 # dep is just waste ;)
1416 %pear_package_setup(a:d:n:zDc:) \
1417 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1418 %define builddir %{_builddir}/%{srcdir} \
1419 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1420 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1421 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1422 %{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1423 %pear_install \
1424 %{-z:cd ..} \
1425 cat %{-z:$_N/}.install.log | %__pear_install_log \
1426 \
1427 # undos sources \
1428 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1429 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1430 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1431 %{nil}
1432
1433 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1434 # Author: Elan Ruusamäe <glen@pld-linux.org>
1435 %pear_package_install() \
1436 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1437 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1438 # help the developer out a little: \
1439 if [ -f _noautoreq ]; then \
1440         echo "AutoReqdep detected:" \
1441         echo "_noautoreq $(cat _noautoreq)" \
1442 fi \
1443 %{nil}
1444
1445
1446 # Register OpenLDAP schema.
1447 # Author: Elan Ruusamäe <glen@pld-linux.org>
1448 #
1449 # Usage:
1450 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1451 #
1452 #  -d specify dependant schemas, separated by comma
1453 #
1454 %openldap_schema_register(d:) \
1455 for schema in %*; do \
1456         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1457                 %{__sed} -i -e " \
1458                         /^include.*local.schema/{ \
1459                                 iinclude\\t     $schema\
1460                         } \
1461                 " /etc/openldap/slapd.conf \
1462         fi \
1463 done \
1464 # enable dependant schemas \
1465 if [ "%{-d*}" ]; then \
1466         %{__sed} -i -e ' \
1467         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1468                 s/^#// \
1469         }' /etc/openldap/slapd.conf \
1470 fi \
1471 %{nil}
1472
1473 # Unregister OpenLDAP schema.
1474 # Author: Elan Ruusamäe <glen@pld-linux.org>
1475 #
1476 # Usage:
1477 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1478 #
1479 %openldap_schema_unregister() \
1480 for schema in %*; do \
1481         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1482                 %{__sed} -i -e " \
1483                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1484                 # for symmetry it would be nice if we disable enabled schemas in post, \
1485                 # but we really can not do that, it would break something else. \
1486                 " /etc/openldap/slapd.conf \
1487         fi \
1488 done \
1489 %{nil}
1490
1491 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1492
1493
1494 # Build modules for kernels 2.6
1495 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1496 #
1497 # Usage:
1498 #       %build_kernel_modules -m <modules> -C <directory>
1499 #
1500 #  remember that proper Makefile is still required
1501 # Options:
1502 #  -m <modules> (required) -- comma-separated list of modules to save,
1503 #               without .ko extension, may be placed in subdirectory
1504 #  -C <directory> -- change to <directory> before doing anything
1505 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1506 #  -c -- do not execute make clean
1507 #  <additional arguments> -- all additional arguments will be passed to
1508 #               make modules
1509 #
1510 # Additional patching supported via here document. Try:
1511 #       %build_kernel_modules -m module <<'EOF'
1512 #       your patch script here
1513 #       EOF
1514 # Don't use it unless patching depends on config options.
1515
1516 # Developer note: don't touch it unless you know how to handle '\'.
1517 # - \ in script expands to nothing
1518 # - \\\ in script expands to \
1519 # - \\\ inside definition expands to nothing
1520 # - \\\\\\\ inside definition expands to \
1521 # - in last line \ has to touch arguments so arguments passing
1522 #   in new lines (using \) will be supported
1523
1524 %build_kernel_modules(p:P:m:C:c)                                                                        \
1525 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1526                                                                                                                                         \
1527 %define Opts                                                                                                            \\\\\\\
1528 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1529         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1530         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1531         %else                                                                                                                   \\\
1532         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1533         %endif                                                                                                                  \\\
1534 %else                                                                                                                           \\\
1535         CC="%{kgcc}"                                                                                                    \\\
1536 %endif                                                                                                                          \
1537 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1538                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1539                                                                                                                                         \
1540 %{?-C:cd %{-C*}}                                                                                                        \
1541 compile() {                                                                                                                     \
1542         local L="<" PATCH_SH;                                                                                   \
1543         [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"                   \
1544         set -e -x                                                                                                               \
1545         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1546                                                                                                                                         \
1547 for cfg in ${cfgs:-dist}; do                                        \
1548         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1549                                                                                                                                         \
1550         rm -rf o                                                                                                                \
1551         install -d o/include/linux o/include/generated o/arch/powerpc/lib       \
1552         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1553         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1554         if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then      \
1555                 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1556                 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1557         else                                                                                                                    \
1558                 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1559         fi                                                                                                                              \
1560                                                                                                                                         \
1561         set +x                                                                                                                  \
1562         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1563         set -x                                                                                                                  \
1564                                                                                                                                         \
1565         %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?)  \
1566                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1567                         %{-p*} %{-P*}                                                                                   \\\
1568                         %{MakeOpts}                                                                                             \
1569         %else                                                                                                                   \
1570                 install -d o/include/config                                                                     \
1571                 touch o/include/config/MARKER                                                           \
1572                 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf        \
1573                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1574         %endif                                                                                                                  \
1575                                                                                                                                         \
1576         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1577                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1578                 ${1+"$@"}                                                                                                       \\\
1579                 M=$PWD %{MakeOpts}}                                                                                     \
1580                                                                                                                                         \
1581         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1582                 ${1+"$@"}                                                                                                       \\\
1583                 M=$PWD %{MakeOpts}                                                                                      \
1584                                                                                                                                         \
1585         for MODULE in {%{-m*},}; do                                                                             \
1586                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1587         done                                                                                                                    \
1588 done                                                                                                                            \
1589 %{?-C:cd -}                                                                                                                     \
1590 }                                                                                                                                       \
1591 compile %{*}\
1592 %{nil}
1593
1594
1595 # Install kernel modules built by %build_kernel_modules
1596 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1597 #
1598 # Usage:
1599 #       %install_kernel_modules -m <modules> -d <directory>
1600 #
1601 # Options:
1602 #  -m <modules> (required) -- comma-separated list of modules to install,
1603 #               without .ko extension, may be placed in subdirectory
1604 #  -d <directory> (required) -- in what subdirectory modules should be
1605 #               installed (eg. misc, kernel/drivers/net)
1606 #  -s <suffix> -- suffix to use when installing modules, useful when module
1607 #               with same name exists in kernel already
1608 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1609 #               for defining aliases, only useful with -s
1610
1611 %install_kernel_modules(m:d:s:n:)                                                                       \
1612 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1613 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1614 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1615                                                                                                                                         \
1616 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1617 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1618                                                                                                                                         \
1619 __install_kernel_modules() {                                                                            \
1620 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1621                                                                                                                                         \
1622 for MODULE in {%{-m*},}; do                                                                                     \
1623         [ -n "${MODULE}" ] || continue                                                                  \
1624         for cfg in ${cfgs:-dist}; do                                    \
1625                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1626                 MNAME=${MODULE##*/}                                                                                     \
1627                 install -D ${MODULE}-$cfg.ko                                                            \\\
1628                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1629                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1630                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1631                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1632         done                                                                                                                    \
1633 done                                                                                                                            \
1634 }                                                                                                                                       \
1635 __install_kernel_modules                                                                                        \
1636 %{nil}
1637
1638 # patchset macros
1639 # Author: Elan Ruusamäe <glen@pld-linux.org>
1640 #
1641 # Usage:
1642 #   %patchset_source -f <seq(1) format> <start> [<end>]
1643 #   %patchset_patch <start> [<end>]
1644 #
1645 # If <end> is omited, it is assumed to be <start>.
1646 #
1647 # For example in preamble:
1648 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1649 # and in %prep:
1650 #  %patchset_patch 33 44
1651
1652 # generate SourceX urls from range START STOP
1653 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1654 # The sources start from 10000
1655 %patchset_source(f:b:) %(
1656         base=%{-b*}%{!-b*:10000};
1657         start=$(expr $base + %1);
1658         end=$(expr $base + %{?2}%{!?2:%{1}});
1659         # we need to call seq twice as it doesn't allow two formats
1660         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1661         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1662         paste %{tmpdir}/__ps{1,2};
1663         rm -f %{tmpdir}/__ps{1,2};
1664 ) \
1665 %{nil}
1666
1667 # apply sources from %patchset_source
1668 # -p specify -pX for %patch line
1669 # -b base offset: defaults to 10000
1670 %patchset_patch(f:p:b:) %(
1671         base=%{-b*}%{!-b*:10000};
1672         start=$(expr $base + %1);
1673         end=$(expr $base + %{?2}%{!?2:%{1}});
1674         echo ": patchset_patch %1%{?2: to %2}";
1675         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1676 ) \
1677 %{nil}
1678
1679 # browser plugins v2
1680 # Author: Elan Ruusamäe <glen@pld-linux.org>
1681 #
1682 # Usage:
1683 #       %browser_plugins_add_browser <name> -p <plugindir>
1684 #
1685 #  <name> (required) -- name of the browser. usually %{name}.
1686 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1687 #  -b -- default blacklists
1688 #  -a <arch> override arch
1689 #
1690 # Example:
1691 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1692
1693 %_browserpluginsconfdir         /etc/browser-plugins
1694 %_browserpluginsdir                     %{_libdir}/browser-plugins
1695 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1696
1697 %browser_plugins_add_browser(p:b:a:) \
1698         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1699         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1700         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1701         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1702         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1703         %{-b:cat >> $blacklist_file %{-b*}} \
1704 %{nil}
1705
1706 # Helper for LUA.
1707 # split string separated by space into quoted list
1708 #
1709 # Author: Elan Ruusamäe <glen@pld-linux.org>
1710 #
1711 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1712 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1713
1714 # adjust /etc/shells by adding and removing shells from there
1715 # Author: Elan Ruusamäe <glen@pld-linux.org>
1716 #
1717 # Usage:
1718 #   %post       -p <lua>
1719 #   %lua_add_etc_shells /bin/sh /bin/pdksh
1720 #
1721 #   %preun      -p <lua>
1722 #   if arg[2] == 0 then
1723 #       %lua_remove_etc_shells /bin/bash /bin/rbash
1724 #   end
1725 #
1726 # Requirements:
1727 # BuildRequires:        rpmbuild(macros) >= 1.462
1728 #
1729
1730 %lua_add_etc_shells() \
1731 t = {}\
1732 f = io.open("/etc/shells", "r")\
1733 if f then\
1734         for l in f:lines() do t[l]=l; end\
1735         f:close()\
1736 end\
1737 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1738         if not t[s] then\
1739                 print("Adding "..s.." to /etc/shells")\
1740                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1741         end\
1742 end\
1743 %{nil}
1744
1745 %lua_remove_etc_shells() \
1746 t = {}\
1747 f = io.open("/etc/shells", "r")\
1748 if f then\
1749         for l in f:lines() do t[l]=l; end\
1750         f:close()\
1751 end\
1752 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1753         print("Removing "..l.." from /etc/shells")\
1754         t[l] = nil\
1755 end\
1756 s=""\
1757 for _, l in pairs(t) do\
1758         s=s..l.."\\n"\
1759 end\
1760 io.open("/etc/shells", "w"):write(s)\
1761 %{nil}
1762
1763 # Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1764 #
1765 # Author: Elan Ruusamäe <glen@pld-linux.org>
1766 #
1767 # Usage:
1768 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1769 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1770 #
1771 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1772 #
1773 # Requirements:
1774 # BuildRequires:        rpmbuild(macros) >= 1.429
1775 #
1776 %add_etc_shells(p) %{-p:<lua>}\
1777 %{expand:%%lua_add_etc_shells %*}\
1778 %{nil}
1779
1780 %remove_etc_shells(p) %{-p:<lua>}\
1781 %{-p:if arg[2] == 0 then}\
1782 %{expand:%%lua_remove_etc_shells %*}\
1783 %{-p:end} \
1784 %{nil}
1785
1786 # Check syntax for Python files
1787 #
1788 # Author: Elan Ruusamäe <glen@pld-linux.org>
1789 # Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1790 #
1791 # Usage:
1792 #   %py_lint src
1793 #
1794 # Requirements:
1795 # BuildRequires:        python
1796 # BuildRequires:        rpmbuild(macros) >= 1.469
1797
1798 %py_lint() \
1799 __py_lint() { \
1800 find "$@" -type f -name '*.py' | python -c ' \
1801 import sys \
1802 import compiler \
1803 \
1804 err = 0\
1805 for f in sys.stdin: \
1806         fd = open(f.strip()) \
1807         c = fd.read() \
1808         fd.close() \
1809         try: \
1810                 compiler.parse(c) \
1811         except SyntaxError, e: \
1812                 print "py_lint: %s: %s" % (f.strip(), e) \
1813                 err = err + 1\
1814 \
1815 if err: \
1816         print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1817         sys.exit(1) \
1818 else: \
1819         print >> sys.stderr,  "py_lint: Found no syntax errors." \
1820 ' \
1821 }; __py_lint %* \
1822 %{nil}
1823
1824 # Undos files
1825 #
1826 # Author: Paweł Zuzelski <pawelz@pld-linux.org>
1827 # Author: Elan Ruusamäe <glen@pld-linux.org>
1828 #
1829 # Usage:
1830 #   %undos list_of_files
1831 #   %undos -f EXT[,EXT]
1832 #   %undos -i -f EXT[,EXT]
1833 #
1834 #  -f EXT[,EXT] - find(1) files by extensions
1835 #  -i - case insensitive file search
1836 #
1837 # Example:
1838 #   Un-DOS all *.js, *.css files
1839 #   %undos -f js,css
1840 #   Un-DOS all *.js, *.JS files
1841 #   %undos -f js -i
1842 #   undos all Makefiles
1843 #   %{__find} -name Makefile | xargs %undos
1844 #
1845 # Requirements:
1846 # BuildRequires:        sed >= 4.0
1847 # BuildRequires:        rpmbuild(macros) >= 1.565
1848
1849 # NB: make sure this macro stays on one line
1850 # NB: make sure it includes newline escape
1851 %undos(f:i)     %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1852 %{nil}
1853
1854 # Hook to register nagios object based plugins in Nagios NRPE daemon config.
1855 #
1856 # Author: Elan Ruusamäe <glen@pld-linux.org>
1857 #
1858 # Usage:
1859 #  -a NAME  -- add command named NAME
1860 #  -d NAME  -- remove command named NAME
1861 #  -f FILE  -- specify plugin configuration FILE to extract command definition from
1862 #
1863 # Sample:
1864 # %triggerin -- nagios-nrpe
1865 # %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1866 #
1867 # %triggerun -- nagios-nrpe
1868 # %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1869 #
1870 # Requirements:
1871 # Requires:                     grep
1872 # Requires:                     sed >= 4.0
1873 # BuildRequires:        rpmbuild(macros) >= 1.552
1874 %nagios_nrpe(a:d:c:f:) {\
1875         m=$(md5sum < /etc/nagios/nrpe.cfg); \
1876         %{-a:# on -a and config exists \
1877         if [ -f /etc/nagios/nrpe.cfg ]; then \
1878                 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1879                                 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
1880                 fi; \
1881         fi;} \
1882         %{-d:# on package remove, -d and config exists \
1883         if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1884                 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
1885         fi;} \
1886         if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1887                 %service -q nrpe restart; \
1888         fi; \
1889 }%{nil}
1890
1891 # Import or update Cacti template.
1892 #
1893 # Author: Elan Ruusamäe <glen@pld-linux.org>
1894 #
1895 # Usage:
1896 # %cacti_import_template XMLFILE
1897 #  XMLFILE -- XML template to import
1898 #
1899 # Sample:
1900 # %post
1901 # %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1902 #
1903 # Requires:     cacti >= 0.8.7e-8
1904 # BuildRequires:        rpmbuild(macros) >= 1.554
1905
1906 %cacti_import_template() {\
1907 /usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1908 }%{nil}
1909
1910 # pre/post script for -upstart subpackages
1911 #
1912 # Author: Jacek Konieczny <jajcus@jajcus.net>
1913 #
1914 # Usage:
1915 #       %upstart_post service_name
1916 #   %upstart_postun service_name
1917 #
1918 # Sample:
1919 # %post upstart
1920 # %upstart_post %{name}
1921 #
1922 # %postun upstart
1923 # %upstart_postun %{name}
1924 #
1925 # Requirements:
1926 # BuildRequires:        rpmbuild(macros) >= 1.560
1927 # Requires:                     rc-scripts >= 0.4.3
1928
1929 # migrate from init script to upstart job
1930 %upstart_post() \
1931         if [ -f /var/lock/subsys/"%1" ] ; then \
1932                 /sbin/service --no-upstart "%1" stop \
1933                 /sbin/service "%1" start \
1934         fi
1935
1936 # restart the job after upgrade or migrate to init script on removal
1937 # cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1938 # at this point
1939 %upstart_postun() \
1940         if [ -x /sbin/initctl ] && /sbin/initctl status "%1" 2>/dev/null | grep -q 'running' ; then \
1941                 /sbin/initctl stop "%1" >/dev/null 2>&1 \
1942                 [ -f "/etc/rc.d/init.d/%1" -o -f "/etc/init/%1.conf" ] && { echo -n "Re-" ; /sbin/service "%1" start ; } ; \
1943         fi
1944
1945 # vim:ts=4 sw=4 noet ft=spec
This page took 0.298342 seconds and 4 git commands to generate.